﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MySQLQueryMonitor.Util;
using System.Collections.ObjectModel;
using System.Windows.Media;

namespace MySQLQueryMonitor.ViewModel
{
    class FontFamilyViewModel : List<GroupedItem<FontFamily>>
    {
        public FontFamilyViewModel()
        {
            var fonts = new List<GroupedItem<FontFamily>>();
            string[] recommendedFonts = new string[] {
                "Consolas",
                "Courier New",
                "Lucida Console",
            };
            AddRange(
                from font in FontUtil.GetFontFamilyFromFamilyName(recommendedFonts)
                select new GroupedItem<FontFamily>(font, "Recommended Fonts"));
            AddRange(
                from font in Fonts.SystemFontFamilies
                select new GroupedItem<FontFamily>(font, "All Fonts"));
        }

    }
}
